"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ReactItemPropertiesWidget = void 0;
const React = __importStar(require("react"));
require("../../style/output-components-style.css");
const signal_manager_1 = require("traceviewer-base/lib/signals/signal-manager");
const tree_1 = require("../components/utils/filter-tree/tree");
class ReactItemPropertiesWidget extends React.Component {
    constructor(props) {
        super(props);
        /** Tooltip Signal and Signal Handlers */
        this._onItemProperties = (data) => this.doHandleItemPropertiesSignal(data.getProperties());
        this.getSourceCodeElement = (key, value, fileLocation, line) => (React.createElement("span", { className: "source-code-tooltip", key: key, title: value, onClick: this.props.handleSourcecodeLookup, "data-id": JSON.stringify({ fileLocation, line }) }, value));
        this.state = {
            itemProperties: []
        };
        (0, signal_manager_1.signalManager)().on(signal_manager_1.Signals.ITEM_PROPERTIES_UPDATED, this._onItemProperties);
    }
    componentWillUnmount() {
        (0, signal_manager_1.signalManager)().off(signal_manager_1.Signals.ITEM_PROPERTIES_UPDATED, this._onItemProperties);
    }
    render() {
        return (React.createElement("div", { className: "trace-explorer-item-properties" },
            React.createElement("div", { className: "trace-explorer-panel-content" }, this.renderTooltip())));
    }
    renderTooltip() {
        if (this.state.itemProperties) {
            return (React.createElement("div", { className: "scrollable item-properties-table" },
                React.createElement(tree_1.FilterTree, { className: "table-tree", nodes: this.state.itemProperties, showCheckboxes: false, showFilter: false, showHeader: true, hideFillers: true, onRowClick: () => {
                        // do nothing
                    }, headers: [
                        { title: 'Key', sortable: true, resizable: true },
                        { title: 'Value', resizable: true }
                    ] })));
        }
        return React.createElement(React.Fragment, null);
    }
    doHandleItemPropertiesSignal(tooltipProps) {
        const entries = [];
        Object.entries(tooltipProps).forEach(([key, value], index) => {
            const node = {
                id: index,
                parentId: -1,
                labels: [key, value],
                children: [],
                isRoot: true,
                showTooltip: true
            };
            if (key === 'Source') {
                const sourceCodeInfo = value;
                const matches = sourceCodeInfo.match('(.*):(\\d+)');
                let fileLocation;
                let line;
                if (matches && matches.length === 3) {
                    fileLocation = matches[1];
                    line = matches[2];
                }
                // labels index for which the element needs to be rendered
                node.elementIndex = 1;
                node.getElement = () => this.getSourceCodeElement(key, value, fileLocation, line);
            }
            entries.push(node);
        });
        this.setState({ itemProperties: entries });
    }
}
exports.ReactItemPropertiesWidget = ReactItemPropertiesWidget;
//# sourceMappingURL=trace-explorer-properties-widget.js.map